SystemOrganization addCategory: #'OB-Standard-Nodes'!
SystemOrganization addCategory: #'OB-Standard-Tests'!
SystemOrganization addCategory: #'OB-Standard-Utilities'!

TestResource subclass: #OBBrowserResource
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBBrowserResource methodsFor: 'accessing' stamp: 'cwp 2/16/2004 21:19'!
model
	^ model! !

OBBrowserResource subclass: #OBImageBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBImageBrowserResource methodsFor: 'running' stamp: 'cwp 2/16/2004 22:01'!
metaGraph
	^ OBMetaGraphBuilder default imageBrowser! !

!OBImageBrowserResource methodsFor: 'running' stamp: 'cwp 2/16/2004 22:01'!
node
	^ OBSystemNode on: OBImageContext new! !

!OBBrowserResource methodsFor: 'running' stamp: 'cwp 3/22/2004 19:56'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self node.
	model addPanel: (OBDefinitionPanel inBrowser: model).
	morph _ model window.! !

!OBBrowserResource methodsFor: 'accessing' stamp: 'cwp 2/16/2004 21:19'!
morph
	^ morph! !

TestResource subclass: #OBSourceFilesResource
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBSourceFilesResource methodsFor: 'initializing' stamp: 'cwp 5/11/2004 11:24'!
sourceString
	^ '!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05''!!
one
	^ 1!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
two
	^ 1!! !!
!!OBFakeClassC class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
three
	^ 1!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777294!!
one
	^ 2!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777384!!
two
	^ 2!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777588!!
one
	^ 3!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777694!!
two
	^ 3!! !!'! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: 'cwp 5/11/2004 11:25'!
changesString
	^ '!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05'' prior: 16777800!!
one
	^ 4!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777906!!
two
	^ 4!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554526!!
one
	^ 5!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554632!!
two
	^ 5!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554738!!
one
	^ 6!! !!
!!OBFakeClassC methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554844!!
two
	^ 6!! !!
!!OBFakeClassC class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777480!!
three
	^ 2!! !!'! !

!OBSourceFilesResource methodsFor: 'accessing' stamp: 'cwp 3/13/2004 22:40'!
sources
	^ sources! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: 'cwp 3/13/2004 22:38'!
changesStream
	^ ReadStream on: self changesString! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: 'cwp 3/13/2004 22:38'!
setUp
	sources _ StandardSourceFileArray new: 2.
	sources at: 1 put: self sourceStream.
	sources at: 2 put: self changesStream.! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: 'cwp 3/13/2004 22:38'!
sourceStream
	^ ReadStream on: self sourceString! !

OBBrowserTest subclass: #OBInheritanceBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 5/30/2004 17:07'!
targetNode
	^ OBMethodNode nakedOn: #isString inClass: BogusInfo aRef inContext: OBImageContext new.! !

!OBInheritanceBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 17:08'!
testInitialDisplay
	self 
		assertListAt: 1 contains: #('Object>>isString');
		assertListAt: 2 contains: #('BogusA>>isString' 'String>>isString');
		assertListAt: 3 contains: #('BogusE>>isString');
		assertCurrentItemIs: 'BogusA>>isString'! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 3/22/2004 19:56'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self rootNode.
	model 
		minPanes: 3;
		maxPanes: 3;
		addPanel: (OBDefinitionPanel inBrowser: model);
		jumpTo: self targetNode.
	morph _ model window.! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 3/22/2004 23:42'!
rootNode
	^ OBCollectionNode on: {OBMethodNode 
							nakedOn: #isString 
							inClass: (OBClassReference to: Object) 
							inContext: OBImageContext new}! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 3/15/2004 22:05'!
metaGraph
	^ OBBrowser metaGraphAt: #MethodInheritance! !

OBBrowserTest subclass: #OBChasingBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBChasingBrowserTest methodsFor: 'running' stamp: 'cwp 5/30/2004 09:06'!
node
	^ OBMethodNode
		on: #five
		inClass: BogusInfo aRef
		inContext: (OBImageContext new)! !

!OBChasingBrowserTest methodsFor: 'testing' stamp: 'cwp 2/29/2004 20:55'!
testMessageText
	self select: 'five'.
	self assertTextIs: self fiveSource.
	self assertSelectedTextIs: ''! !

!OBChasingBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 09:06'!
testSelectionClearing
	self select: 'five'.
	self select: 'OBChasingBrowserTest>>node'.
	self clickButtonLabeled: 'implementors'.
	self assertListAt: 1 includes: #('five').
	self assertListAt: 2 includes: #('BogusA>>five').
	self denyAListIncludes: #(default on: on:inClass:inContext:)! !

!OBChasingBrowserTest methodsFor: 'running' stamp: 'cwp 2/26/2004 22:37'!
metaGraph
	^ OBBrowser metaGraphAt: #ChaseSenders ! !

!OBChasingBrowserTest methodsFor: 'contants' stamp: 'cwp 5/30/2004 09:05'!
fiveSource
	^ BogusInfo aFiveSource! !

!OBChasingBrowserTest methodsFor: 'testing' stamp: 'cwp 2/29/2004 19:39'!
testMessageTextThree
	self select: 'three'.
	self assertTextIs: self fiveSource.
	self assertSelectedTextIs: 'three'! !

OBBrowserTest subclass: #OBVersionsBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'cwp 3/22/2004 23:39'!
node
	^ OBMethodNode on: #two inClass: (OBClassReference named: #OBFakeClassC) inContext: self! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 23:07'!
testSourceDisplay
	self select: 'cwp 3/11/2004 20:07 OBFakeClassC>>two'.
	self assertTextIs: self twoLatestVersionText! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: 'cwp 3/14/2004 23:08'!
twoLatestVersionText
	^  'two
	^ 6' asText makeSelectorBold! !

!OBVersionsBrowserTest methodsFor: 'emulating' stamp: 'cwp 3/13/2004 22:41'!
sourceFiles
	^ OBSourceFilesResource current sources! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: 'cwp 3/13/2004 22:04'!
testInitialDisplay
	self assertListAt: 1 contains: self expectedHeadings! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'cwp 3/13/2004 22:02'!
metaGraph
	^ OBBrowser metaGraphAt: #Versions! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: 'cwp 3/14/2004 23:05'!
expectedHeadings
	^ #('cwp 3/11/2004 20:07 OBFakeClassC>>two' 'cwp 3/11/2004 20:06 OBFakeClassC>>two' 'cwp 3/11/2004 20:06 OBFakeClassC>>two' 'cwp 3/11/2004 20:07 OBFakeClassC>>two' 'cwp 3/11/2004 20:06 OBFakeClassC>>two' 'cwp 3/11/2004 20:06 OBFakeClassC>>two')! !

!OBVersionsBrowserTest methodsFor: 'emulating' stamp: 'cwp 3/14/2004 22:52'!
sourcePointerFor: aMethodReference
	| pointer |
	pointer _ self sourceFiles sourcePointerFromFileIndex: 2 andPosition: 624.
	^ pointer.! !

OBBrowserTest subclass: #OBCodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:48'!
methodOne
	^ 'one
	^ 1'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testEditComment
	self selectBogusCategory.
	self select: 'BogusB'.
	self switchToComment.
	self setText: self bogusBComment.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertCurrentItemIs: #BogusB.
	self assert: BogusB comment = self bogusBComment! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testSelectAllMethodCategory
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: '-- all --'.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three' 'five' 'a' 'b').
	self assertTextIs: self methodTemplate! !

OBCodeBrowserTest subclass: #OBImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:14'!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:19'!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBImageBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:19'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: {BogusInfo baseCategory}.
	self assertTextIs: ''.
	! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:14'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBImageBrowserTest class methodsFor: 'resources' stamp: 'cwp 2/16/2004 21:59'!
resources
	^ Array with: OBImageBrowserResource ! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:15'!
bogusCategoryName
	^ BogusInfo baseCategory! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:43'!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 5/30/2004 10:38'!
selectBogusCategory
	self select: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testSelectCategory
	self selectBogusCategory.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertTextIs: self classTemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:33'!
fakeClassBComment
	self deprecated: 'Use #bogusBComment'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:54'!
fakePackageName
	self deprecated: 'Use BogusInfo>>packageName'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 11:00'!
testColumnClearing
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'numbers'.
	self select: 'one'.
	self switchToClassSide.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('testing' 'capitals').
	self denyAListIncludes: #('letters' 'numbers').
	self denyAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:45'!
testJumpToMethodOne
	self selectBogusPackage.
	model jumpTo: (OBMethodNode 
					on: #one 
					inClass: BogusInfo aRef
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'one'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/16/2004 22:09'!
browserResource
	^ self class resources first current! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/16/2004 22:16'!
setUp
	model _ self browserResource model.
	morph _ self browserResource morph. 
	model jumpToRoot.	
! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testSelectBogusA
	self selectBogusCategory.
	self select: 'BogusA'.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertTextIs: self bogusATemplate! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 3/1/2004 00:03'!
runCaseAsFailure: aSemaphore
	SystemChangeNotifier uniqueInstance doSilently: [super runCaseAsFailure: aSemaphore]! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 5/30/2004 10:37'!
deselectBogusCategory
	self deselect: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:40'!
testCreateMethodFromTemplate
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'letters'.
	self setText: self methodFour.
	self assertAListMatches: #('a' 'b' 'four').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:39'!
testEditMethod
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self altMethodOne.
	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: 11 = BogusA new one! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:50'!
testSelectBogusAClassSide
	self selectBogusCategory.
	self select: 'BogusA'.
	self switchToClassSide.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('capitals').
	self assertCurrentItemIs: #BogusA.
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:54'!
fakeClassCDefinition
	self deprecated: 'Use #bogusCDefinition'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:45'!
testJumpToFakes
	self selectBogusPackage.
	model jumpTo: (OBClassCategoryNode 
					on: self bogusCategoryName 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:44'!
testJumpToBogusA
	self selectBogusPackage.
	model jumpTo: (OBClassNode 
					on: BogusInfo aRef 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'BogusA'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testDeselectFakeA
	self selectBogusCategory.
	self select: 'BogusA'.
	self deselect: 'BogusA'.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: self classTemplate.! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 5/30/2004 10:40'!
selectBogusPackage
	! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 3/1/2004 00:03'!
runCase
	SystemChangeNotifier uniqueInstance doSilently: [super runCase]! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 20:00'!
methodA
	^ 'a
	^ $A'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:30'!
fakeAComment
	self deprecated: 'Use BogusInfo>>aComment instead'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:45'!
testJumpToNumbers
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'numbers' 
					inClass: BogusInfo aRef
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'numbers'.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:52'!
testEditClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusCDefinition.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertCurrentItemIs: #BogusC.
	self assert: BogusC instVarNames = #(foo)! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:45'!
testJumpToCapitals
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'capitals' 
					inClass: (BogusInfo aMetaRef)
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'capitals'.
	self assertIsClassSide.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:51'!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', self bogusPackageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 10:53'!
bogusAClassTemplate
	^  'BogusA class
	instanceVariableNames: '''''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:38'!
testButtonRemoval
	self selectBogusCategory.
	self select: 'BogusA'.
	self deselectBogusCategory.
	self assertNoButtonsVisible.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 18:57'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:38'!
testCreateMethodFromMethod
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 01:11'!
switchToComment
	self clickButtonLabeled: '?'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:49'!
testSelectBogusAComment
	self selectBogusCategory.
	self select: 'BogusA'.
	self switchToComment.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertCurrentItemIs: #BogusA.
	self assertTextIs: BogusInfo aComment.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 19:57'!
altMethodA
	^ 'a
	^ $B'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:53'!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:39'!
testEditClassMethod
	self selectBogusCategory.
	self select: 'BogusA'.
	self switchToClassSide.
	self select: 'capitals'.
	self select: 'a'.
	self setText: self altMethodA.
	self assertAListMatches: #('a' 'b').
	self assertCurrentItemIs: 'a'.
	self assert: $B = BogusA a! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:59'!
methodFour
	^ 'four
	^ 4'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:52'!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 5/30/2004 10:35'!
tearDown
	super tearDown.
	BogusBuilder 
		defineC;
		defineD;
		compileOne;
		compileA;
		compileFour;
		commentB! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:31'!
fakeATemplate
	self deprecated: 'Use #bogusATemplate instead'! !

!OBCodeBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/29/2004 14:30'!
assertIsClassSide
	self assertButtonSelected: 'class'! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 13:08'!
isAbstract
	^ self name = #OBCodeBrowserTest! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:40'!
testCreateClassFromTemplate
	self selectBogusCategory.
	self setText: self bogusDDefinition.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:50'!
testSelectOne
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'numbers'.
	self select: 'one'.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: BogusInfo aOneSource! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:26'!
fakeAClassTemplate
	^  self deprecated: 'Use #bogusAClassTemplate'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:40'!
testCreateClassFromClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusDDefinition.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD ! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:44'!
methodTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 10:48'!
testSelectNumbers
	self selectBogusCategory.
	self select: 'BogusA'.
	self select: 'numbers'.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: BogusInfo baseClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self methodTemplate.
	self assertTextIsSelected.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:32'!
bogusBComment
	^ 'A comment for BogusB'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:47'!
altMethodOne
	^ 'one
	^ 11'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 09:54'!
fakeClassDDefinition
	self deprecated: 'Use #bogusDDefinition'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 01:10'!
switchToClassSide
	self clickButtonLabeled: 'class'! !

OBBrowserTest subclass: #OBAccessBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBAccessBrowserTest methodsFor: 'running' stamp: 'cwp 3/14/2004 19:03'!
metaGraph
	^ OBBrowser metaGraphAt: #ChaseVariables! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 08:53'!
testSelectIVarAccessor
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self assertListAt: 3 includes: #('BogusB>>sendsAccessesIvar')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 08:54'!
testSelectIvar
	self select: 'firstInstanceVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesIvar')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 08:53'!
testSelectCVar
	self clickButtonLabeled: 'class'.
	self select: 'FirstClassVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesCVar' 
								   'BogusB class>>accessesCVarAlso')! !

!OBAccessBrowserTest methodsFor: 'running' stamp: 'cwp 8/25/2004 17:42'!
node
	^ OBClassNode on: BogusInfo bRef inContext: OBImageContext new! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 08:56'!
testSelectSender
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self select: 'BogusB>>sendsAccessesIvar'.
	self assertListAt: 4 contains: #('BogusB>>sendsSendsAccessesIvar')
! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 08:52'!
testInitalDisplay
	self assertListAt: 1 contains: BogusInfo bInstVarNames! !

!OBBrowser class methodsFor: '*ob-standard-initializing' stamp: 'cwp 5/27/2004 12:14'!
registerImageBrowser
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #browseImage}}.
! !

!OBBrowser class methodsFor: '*ob-standard-convenience' stamp: 'cwp 2/26/2004 20:47'!
browseImage
	^ self 
		browse: #Image
		fromRoot: (OBSystemNode on: OBImageContext new)
		panes: 4
! !

OBNode subclass: #OBCodeNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

OBCodeNode subclass: #OBSystemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBSystemNode class methodsFor: 'as yet unclassified' stamp: 'cwp 3/10/2004 00:26'!
forImage
	^ self on: OBImageContext new! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:58'!
context
	^ context! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:26'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 06:21'!
name 
	^ 'Squeak'! !

!OBSystemNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:19'!
on: aCodeContext
	^ self new context: aCodeContext! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:18'!
context: aCodeContext
	context _ aCodeContext! !

!OBCodeNode methodsFor: 'initializing' stamp: 'cwp 3/16/2004 21:14'!
setContext: aContext
	context _ aContext! !

!OBCodeNode class methodsFor: 'instance creation' stamp: 'cwp 3/16/2004 21:15'!
inContext: aContext
	^ self new setContext: aContext! !

!OBCodeNode methodsFor: 'accessing' stamp: 'cwp 3/3/2004 00:53'!
context
	^ context! !

OBCodeNode subclass: #OBClassAwareNode
	instanceVariableNames: 'classRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

OBClassAwareNode subclass: #OBMethodVersionNode
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodVersionNode methodsFor: 'displaying' stamp: 'cwp 3/14/2004 23:09'!
text
	^ version source! !

!OBMethodVersionNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 23:51'!
browse
	| class method |
	class _ self theClass.
	method _ (class compiledMethodAt: version selector).
	VersionsBrowser
		browseVersionsOf: method
		class: class
		meta: class isMeta
		category: self category
		selector: version selector! !

!OBMethodVersionNode methodsFor: 'initializing' stamp: 'cwp 3/22/2004 23:24'!
setVersion: aMethodVersion context: aCodeContext
	version _ aMethodVersion.
	classRef _ version classRef.
	context _ aCodeContext! !

!OBMethodVersionNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 23:55'!
actions
	^ {self action: #browse buttonLabel: 'browse' menuLabel: 'browse in standard browser'.
	   self action: #revert buttonLabel: 'revert' menuLabel: 'revert to selected version'}! !

!OBMethodVersionNode methodsFor: 'displaying' stamp: 'cwp 3/21/2004 21:33'!
name
	^ version stamp, ' ', version theClassName, '>>', version selector! !

!OBMethodVersionNode methodsFor: 'compiling' stamp: 'cwp 3/14/2004 23:26'!
accept: aText notifying: aController
	| newSelector |
	newSelector _ self compileMethod: aText notifying: aController.
	newSelector ifNil: [^ false].
	newSelector = version selector ifFalse: [(self methodNodeFor: newSelector) signalSelection].
	^ true! !

!OBMethodVersionNode methodsFor: 'accessing' stamp: 'cwp 3/14/2004 23:34'!
category
	^ context methodCategoryOf: self reference! !

!OBMethodVersionNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 00:05'!
revert
	version fileIn! !

!OBMethodVersionNode methodsFor: 'accessing' stamp: 'cwp 3/21/2004 21:32'!
reference
	^ self referenceForMethod: version selector ofClass: self theClassName.! !

!OBMethodVersionNode class methodsFor: 'instance creation' stamp: 'cwp 3/14/2004 23:30'!
on: aMethodVersion inContext: aCodeContext
	^ self new setVersion: aMethodVersion context: aCodeContext! !

OBClassAwareNode subclass: #OBVariableNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBVariableNode methodsFor: 'initializing' stamp: 'cwp 3/22/2004 23:59'!
setName: aString class: aClassReference context: aContext
	name _ aString.
	classRef _ aClassReference.
	context _ aContext! !

!OBVariableNode class methodsFor: 'instance creation' stamp: 'cwp 3/21/2004 23:57'!
on: instVarName inClass: aClassReference inContext: aContext
	^ self new setName: instVarName class: aClassReference context: aContext! !

OBVariableNode subclass: #OBClassVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassVariableNode methodsFor: 'navigating' stamp: 'cwp 3/19/2004 20:48'!
accessors
	^ (context accessesToClassVar: name ofClass: self classRef)
		collect: [:ref | OBMethodNode nakedOn: ref inContext: context]! !

!OBVariableNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:48'!
actions
	^ Array
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
! !

!OBVariableNode methodsFor: 'displaying' stamp: 'cwp 3/10/2004 19:25'!
name
	^ name! !

OBVariableNode subclass: #OBInstanceVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBInstanceVariableNode methodsFor: 'navigating' stamp: 'cwp 3/19/2004 20:49'!
accessors
	^ (context accessesToInstVar: name ofClass: self classRef)
		collect: [:ref | OBMethodNode nakedOn: ref inContext: context]! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 3/19/2004 20:52'!
isDescendantOfClassCat: aClassCategoryNode
	^ (context categoryOf: self classRef) = aClassCategoryNode name! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 3/21/2004 22:48'!
theClassName
	^ self classRef name! !

!OBClassAwareNode methodsFor: 'nodes' stamp: 'cwp 3/21/2004 22:25'!
classNode
	^ OBClassNode on: self classRef inContext: context! !

OBClassAwareNode subclass: #OBMethodCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:09'!
doRemove
	context removeCategory: name fromClass: self classRef.
	self signalDeletion! !

!OBMethodCategoryNode methodsFor: 'testing' stamp: 'cwp 5/13/2004 12:51'!
containsMethod: aMethodReference 
	^ (self classRef = aMethodReference classReference) 
		and: [(context methodCategoryOf: aMethodReference) = name]! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:11'!
remove
	| methods choice |
	methods _ context methodsInCategory: name ofClass: self classRef.
	methods isEmpty ifTrue: [^ self doRemove].
	choice _ OBConfirmationRequest
				prompt:'Are you sure you want to
remove this method category 
and all its methods?'
				confirm: 'Remove'.
	choice ifTrue: [^self doRemove]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 3/1/2004 23:23'!
accept: aText notifying: aController
	| selector |
	selector _ self compileMethod: aText notifying: aController.
	selector ifNil: [^ false].
	(self methodNodeFor: selector) signalSelection! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 5/10/2004 14:33'!
definition
	^ OBMethodDefinition inCategory: self category inClass: self classRef inContext: context! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'cwp 3/19/2004 21:57'!
alphabetizeCategoriesInClass: aClassNode
	aClassNode context sortCategoriesInClass: aClassNode classRef.
	OBListChanged signal! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 2/29/2004 18:28'!
textSelection
	^ 1 to: self text size! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 09:52'!
category
	^ name! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:55'!
actions
	^ Array
		with: (self action: #printOut withLabel: 'print out')
		with: (self action: #fileOut withLabel: 'file out')
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		with: (self action: #chaseVars buttonLabel: 'vars' menuLabel: 'chase variables')
		with: (self action: #remove withLabel: 'remove' withKeystroke: $x withIcon: MenuIcons deleteIcon)
		with: (self action: #rename withLabel: 'rename...')! !

!OBMethodCategoryNode methodsFor: 'drag and drop' stamp: 'cwp 3/2/2004 21:31'!
dropSelector
	^ #dropOnMethodCategory:! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:56'!
actionsForParent: aNode
	^ Array with: (OBAction
					label: 'create category...'
					receiver: self
					selector: #createInClass:
					arguments: (Array with: aNode)
					icon: MenuIcons newIcon)
			with: (OBAction
					label: 'alphabetize categories'
					receiver: self
					selector: #alphabetizeCategoriesInClass:
					arguments: (Array with: aNode))
			with: (OBAction
					label: 'remove empty categories'
					receiver: self
					selector: #removeEmptyCategoriesInClass:
					arguments: (Array with: aNode))
			with: (OBAction
					label: 'categorize all uncategorized'
					receiver: self
					selector: #categorizeAllUncategorizedInClass:
					arguments: (Array with: aNode))
! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 3/21/2004 20:47'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name inClass: self classRef toBe: category.
						name _ category.
						self signalSelection.]! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 13:07'!
isDescendantOfExtCat: anExtensionCatNode
	^ (anExtensionCatNode context classExists: self classRef) not
		and: [(anExtensionCatNode context categoriesForClass: self classRef)
					includes: self name]! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: 'cwp 3/3/2004 01:28'!
ancestrySelector
	^ #isDescendantOfMethodCat:! !

OBMethodCategoryNode subclass: #OBAllMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBAllMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 3/19/2004 22:07'!
methodReferences
	^ context methodsForClass: self classRef! !

!OBAllMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 20:39'!
on: className inContext: aCodeContext
	^ self on: '-- all --' inClass: className inContext: aCodeContext! !

!OBAllMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 3/22/2004 00:11'!
category
	^ 'as yet unclassified'! !

!OBMethodCategoryNode methodsFor: 'navigating' stamp: 'cwp 12/17/2003 18:25'!
methods
	^ self methodReferences collect: [:ref | OBMethodNode on: ref inContext: context]! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 22:46'!
browse
	Browser fullOnClass: self classRef theClass! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 3/20/2004 12:39'!
methodReferences
	^ context methodsInCategory: name ofClass: self classRef! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: 'cwp 3/21/2004 21:29'!
isDescendantOfMethodCat: other
	^ (other theClassName = self theClassName) and: [other name = name]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:45'!
text
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:20'!
removeEmptyCategoriesInClass: aClassNode
	aClassNode context removeEmptyCategoriesInClass: aClassNode classRef.
	OBListChanged signal! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 3/17/2004 22:19'!
name
	^ (name isEmpty)
		ifFalse: [name]
		ifTrue: [(context starLongNameOf: name) allButFirst]! !

!OBMethodCategoryNode methodsFor: 'initializing' stamp: 'cwp 3/22/2004 23:24'!
setName: aString class: aClassReference context: aCodeContext
	name _ aString.
	classRef _ aClassReference.
	context _ aCodeContext! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'cwp 3/22/2004 23:51'!
createInClass: aClassNode
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	catName ifNotNil:	[aClassNode context addCategory: catName toClass: aClassNode classRef.
						(OBMethodCategoryNode 
							on: catName 
							inClass: aClassNode classRef
							inContext: aClassNode context) signalSelection]! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:34'!
fileOut
	context fileOutCategory: name fromClass: classRef! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 11:33'!
isDescendantOfPackage: aPackageNode
	^ (aPackageNode context classExists: self classRef)
		and: [(aPackageNode context categoriesForClass: self classRef) includes: name]! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:19'!
categorizeAllUncategorizedInClass: aClassNode
	aClassNode context categorizeAllUncategorizedMethodsInClass: aClassNode classRef.
	OBListChanged signal
	! !

!OBMethodCategoryNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:51'!
on: aString inClass: aClassReference inContext: aCodeContext
	^ self new setName: aString class: aClassReference context: aCodeContext! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:34'!
printOut
	context printOutCategory: name fromClass: classRef! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 12:07'!
isDescendantOfExtCat: anExtensionCatNode 
	^ (anExtensionCatNode context classExists: self classRef) not 
		and: [(anExtensionCatNode context categoriesForClass: self classRef) isEmpty not]! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:41'!
browse
	Browser fullOnClass: self classRef theClass! !

OBClassAwareNode subclass: #OBClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassNode methodsFor: 'ancestry' stamp: 'cwp 3/3/2004 01:27'!
ancestrySelector
	^ #isDescendantOfClass:! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:29'!
browse
	Browser fullOnClass: self classRef theClass! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:09'!
inspectInstances
	context inspectInstancesOfClass: self nonMetaClassRef! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:07'!
browseUnreferencedClassVars
	context browseUnreferencedClassVarsIn: self nonMetaClassRef! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:08'!
inspectSubInstances
	context inspectSubInstancesOfClass: self nonMetaClassRef! !

!OBClassNode methodsFor: 'ancestry' stamp: 'cwp 3/19/2004 21:13'!
isDescendantOfPackage: aPackageNode
	^ aPackageNode context classExists: self classRef! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:58'!
instanceVariables
	^ (context instanceVariablesForClass: self classRef)
		collect: [:ea | OBInstanceVariableNode on: ea inClass: self classRef inContext: context]! !

!OBClassNode methodsFor: 'initializing' stamp: 'cwp 3/21/2004 22:08'!
setClass: aClassReference context: aCodeContext
	classRef _ aClassReference.
	context _ aCodeContext! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/11/2004 10:21'!
remove
	(OBConfirmationRequest
		prompt: 'Are you certain that you 
want to REMOVE the class ', self theClassName, ' from the system?'
		confirm: 'Remove')
			ifTrue: [context removeClass: self nonMetaClassRef.
					self signalDeletion]! !

OBClassNode subclass: #OBMetaclassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 3/21/2004 22:03'!
setClass: aClassReference context: aCodeContext
	super 
		setClass: aClassReference beMeta
		context: aCodeContext! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:33'!
name 
	^ self nonMetaName! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 3/21/2004 21:10'!
nonMetaName
	^ self classRef theNonMetaName! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:09'!
browseAllCallsOnClass
	context browseAllCallsOnClass: self nonMetaClassRef! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:07'!
copyClass
	| newName |
	newName _ OBTextRequest
			prompt: 'Please type new class name'
			template: classRef theNonMetaName asString.
	newName ifNotNil:	[context copyClass: self nonMetaClassRef toBe: newName asSymbol.
						(OBClassNode 
							on: (OBClassReference named: newName asSymbol)
							inContext: context) signalSelection].! !

!OBClassNode methodsFor: 'accessing' stamp: 'cwp 3/21/2004 22:08'!
theClassName: aSymbol
	self classRef theNonMetaName: aSymbol! !

!OBClassNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 13:36'!
browseUnsentMethods
	context browseUnsentMethodsIn: classRef! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:10'!
fileOut
	context fileOutClass: self nonMetaClassRef! !

!OBClassNode methodsFor: 'displaying' stamp: 'cwp 3/21/2004 21:06'!
name
	^ self classRef name asString! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/16/2004 20:02'!
rename
	| newName |
	newName _ OBTextRequest
				prompt: 'Please type new class name' 
				template: self theClassName asString.
	newName ifNotNil:	[context renameClass: self nonMetaClassRef toBe: newName asSymbol.
						self theClassName: newName.
						OBListChanged signal]! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:54'!
allCategory
	^ OBAllMethodCategoryNode on: self classRef inContext: context! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:10'!
browseUnreferencedInstVars
	context browseUnreferencedInstVarsIn: self nonMetaClassRef! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 5/14/2004 17:15'!
printOut
	context printOutClass: self nonMetaClassRef! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:58'!
classVariables
	^ (context classVariablesForClass: self classRef)
		collect: [:ea | OBClassVariableNode on: ea inClass: self classRef inContext: context]! !

!OBClassNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:54'!
actions
	^ {
		self action: #findMethod withLabel: 'find method...' withKeystroke: $f withIcon: MenuIcons findIcon.
		self action: #printOut withLabel: 'print out'.
		self action: #fileOut withLabel: 'file out'.
		self action: #browseAllCallsOnClass withLabel: 'class refs' withKeystroke: $N.
		self action: #browseUnsentMethods withLabel: 'unsent methods'.
		self action: #browseUnreferencedInstVars withLabel: 'unreferenced inst vars'.
		self action: #browseUnreferencedClassVars withLabel: 'unreferenced class vars'.
		self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser'.
		self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables'.
		self action: #inspectInstances withLabel: 'inspect instances'.
		self action: #inspectSubInstances withLabel: 'inspect subinstances'.
		self action: #copyClass withLabel: 'copy class...'.
		self action: #remove withLabel: 'remove' withKeystroke: $x withIcon: MenuIcons deleteIcon.
		self action: #rename withLabel: 'rename...'.
	}! !

!OBClassNode class methodsFor: 'instance creation' stamp: 'cwp 3/21/2004 22:29'!
on: aClassReference inContext: aCodeContext
	^ self new setClass: aClassReference context: aCodeContext! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:49'!
categories
	^ ((context categoriesForClass: self classRef)
		collect: [:cat | OBMethodCategoryNode on: cat inClass: self classRef inContext: context])
			copyWithFirst: self allCategory! !

!OBClassNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 12:09'!
findMethod
	| selectedSelector |
	selectedSelector _ context findMethodIn: classRef.
	selectedSelector ifNotNil: [(OBMethodNode 
									on: selectedSelector
									inClass: classRef
									inContext: context) signalSelection].! !

!OBClassNode methodsFor: 'accessing' stamp: 'cwp 3/23/2004 21:39'!
definition
	^ OBClassDefinition 
		context: context 
		template: (context definitionForClass: self classRef)! !

!OBClassNode methodsFor: 'drag and drop' stamp: 'cwp 3/19/2004 21:07'!
dropOnClassCategory: aNode
	aNode context setCategoryOf: self classRef to: aNode name.
	self signalSelection! !

!OBClassNode methodsFor: 'nodes' stamp: 'cwp 3/21/2004 21:09'!
classCategoryNode
	^ OBClassCategoryNode on: (context categoryOf: self theClassName) inContext: context! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 3/14/2004 19:10'!
chaseVars
	OBBrowser 
		browse: #ChaseVariables 
		fromRoot: self classNode
		panes: 3! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 5/11/2004 10:14'!
theNonMetaClassName
	^ self nonMetaClassRef name! !

OBClassAwareNode subclass: #OBMethodNode
	instanceVariableNames: 'selector isNaked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodNode methodsFor: 'comparing' stamp: 'cwp 3/21/2004 21:30'!
= other
	^ (other isKindOf: OBMethodNode)
		and: [self theClassName = other theClassName] 
		and: [self selector = other selector]! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 3/15/2004 23:25'!
isDescendantOfMethod: other
	^ other selector = selector! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/4/2004 02:41'!
remove
	| senders choice |
	senders _ context allSendersOf: selector.
	senders isEmpty ifTrue: [^ self doRemove].
	choice _ OBChoiceRequest
				prompt: 'This message has ', senders size asString, ' senders.'
				labels: #('Remove it' 
						'Remove, then browse senders' 
						'Don''t remove, but show me those senders' 
						'Forget it -- do nothing -- sorry I asked')
				values: #(doRemove removeAndBrowse simpleBrowseSenders nil).
	choice ifNotNil: [^ self perform: choice]
! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/11/2004 21:33'!
implementorsOf: aSelector
	^ (context allImplementorsOf: aSelector) 
			collect: [:ref | OBMethodNode nakedOn: ref inContext: context]! !

!OBMethodNode methodsFor: 'nodes' stamp: 'cwp 2/29/2004 20:55'!
messageNode
	^ OBMessageNode fromMethodNode: self! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 3/11/2004 20:53'!
beNaked
	isNaked _ true! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 5/11/2004 11:58'!
browseImplementors
	self browseMessageWithMetagraph: #Implementors! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 5/11/2004 11:56'!
selectMessage
	| messages sel |
	messages _ (context messagesSentBy: selector inClass: self classRef) copyWithFirst: selector.
	sel _ (OBChoiceRequest labels: messages).
	^ sel ifNotNil: [OBMessageNode on: sel inMethodNode: self]! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/11/2004 21:33'!
implementors
	^ self implementorsOf: selector! !

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 3/22/2004 23:06'!
setReference: aMethodReference context: aCodeContext
	self 
		setSelector: aMethodReference methodSymbol
		class: (aMethodReference classReference)
		context: aCodeContext! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/21/2004 20:24'!
doRemove
	context removeMethod: selector fromClass: self classRef.
	self signalDeletion! !

!OBMethodNode methodsFor: 'displaying' stamp: 'cwp 3/21/2004 21:38'!
name
	^ self isNaked
		ifTrue: [self theClassName, '>>', selector]
		ifFalse: [selector]! !

!OBMethodNode methodsFor: 'drag and drop' stamp: 'cwp 3/21/2004 21:31'!
dropOnMethodCategory: aNode

	"We don't support dropping on another class yet."
	aNode classRef = self classRef ifFalse: [^ false].
	
	context setCategoryOf: selector inClass: self classRef toBe: aNode name.
	OBListChanged signal.
	
	^ true! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/15/2004 19:04'!
chaseImplementors
	OBBrowser 
		browse: #ChaseImplementors 
		fromRoot: self copy
		panes: 4! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 3/21/2004 21:37'!
reference
	^ self referenceForMethod: selector ofClass: self theClassName! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 5/11/2004 11:57'!
browseMessageWithMetagraph: aSymbol
	| root |
	root _ self selectMessage.
	root ifNotNil: [OBBrowser browse: aSymbol fromRoot: root]! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 3/19/2004 22:09'!
isDescendantOfPackage: aPackageNode
	^ (aPackageNode context classExists: self classRef)
		and: [((aPackageNode context methodsForClass: self classRef) 
				collect: [:ea | ea methodSymbol]) includes: selector]! !

OBMethodNode subclass: #OBMessageNode
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMessageNode methodsFor: 'navigating' stamp: 'cwp 3/11/2004 21:33'!
implementors
	^ self implementorsOf: message! !

!OBMessageNode class methodsFor: 'instance creation' stamp: 'cwp 3/23/2004 23:01'!
fromMethodNode: aMethodNode
	^ self new 
		setMessage: aMethodNode selector
		selector: aMethodNode selector
		class: aMethodNode classRef
		context: aMethodNode context! !

!OBMessageNode methodsFor: 'navigating' stamp: 'cwp 3/11/2004 22:11'!
sendersOfMessage
	^ self sendersOf: message! !

!OBMessageNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:15'!
on: aSelector inMethodReference: ref inContext: aContext
	^ (self 
		on: aSelector 
		inMethod: ref methodSymbol
		inClass: ref classReference 
		inContext: aContext)
			beNaked! !

!OBMessageNode methodsFor: 'displaying' stamp: 'cwp 3/21/2004 21:13'!
name
	^ self isNaked
		ifTrue: [self theClassName, '>>', selector]
		ifFalse: [message asString]! !

!OBMessageNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:15'!
on: aSelector inMethodNode: aNode
	^ self 
		on: aSelector 
		inMethod: aNode selector 
		inClass: aNode classRef 
		inContext: aNode context! !

!OBMessageNode methodsFor: 'initializing' stamp: 'cwp 3/23/2004 22:57'!
setMessage: aSelector selector: aSelector2 class: aClassReference context: aContext
	message _ aSelector.
	selector _ aSelector2.
	classRef _ aClassReference.
	context _ aContext! !

!OBMessageNode methodsFor: 'accessing' stamp: 'cwp 3/23/2004 23:00'!
definition
	^ OBMethodDefinition
		selection: self selection
		source: self source
		inClass: self classRef
		inContext: context! !

!OBMessageNode methodsFor: 'accessing' stamp: 'cwp 3/23/2004 23:00'!
selection
	| methodNode assoc |
	methodNode _ Parser new 
					parse: self source
					class: self classRef theClass.
	assoc _ (methodNode encoder rawSourceRanges) 
			associations detect: [:ea | ea key isMessage: message receiver: nil arguments: nil]
						ifNone: [nil -> (1 to: 0)].
						"Some messages are generated by the compiler."
	^ assoc value! !

!OBMessageNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:16'!
on: aSelector inMethod: aSelector2 inClass: classRef inContext: aContext
	^ self new setMessage: aSelector selector: aSelector2 class: classRef context: aContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/15/2004 23:47'!
browseInheritance
	OBBrowser 
		browse: #MethodInheritance 
		fromRoot: self inheritanceRoot
		select: self
		minPanes: 4
		maxPanes: 4! !

!OBMethodNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:41'!
fileOut
	context fileOutMethod: selector fromClass: classRef! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/11/2004 21:36'!
simpleBrowseSenders
	OBBrowser browse: #Senders fromRoot: self.! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 12:15'!
isDescendantOfExtCat: anExtensionCatNode 
	^ (anExtensionCatNode context classExists: self classRef) not 
		and: [(anExtensionCatNode context methodsForClass: self classRef)
				includes: self reference]! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:30'!
messages
	^ (context messagesSentBy: selector inClass: self classRef)
		collect: [:sel | OBMessageNode 
						on: sel 
						inMethod: selector 
						inClass: self classRef 
						inContext: context]! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/14/2004 23:31'!
versions
	^ (OBMethodVersion scan: context sourceFiles from: (context sourcePointerFor: self reference))
		collect: [:ea | OBMethodVersionNode on: ea inContext: context]! !

!OBMethodNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:38'!
nakedOn: aSelector inClass: classRef inContext: aCodeContext
	^ (self on: aSelector inClass: classRef inContext: aCodeContext) beNaked! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/22/2004 23:44'!
overrides
	^ (context overridersOf: selector inClass: self classRef)
		collect: [:ea | OBMethodNode nakedOn: selector inClass: ea inContext: context] ! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:08'!
source
	^ context sourceForMethod: selector ofClass: self classRef! !

!OBMethodNode class methodsFor: 'instance creation' stamp: 'cwp 12/10/2003 23:51'!
on: aMethodReference inContext: aCodeContext
	^ self new setReference: aMethodReference context: aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 5/11/2004 11:58'!
browseSenders
	self browseMessageWithMetagraph: #Senders! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 3/3/2004 02:06'!
ancestrySelector
	^ #isDescendantOfMethod: ! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 3/23/2004 22:29'!
definition
	^ OBMethodDefinition
		source: (context sourceForMethod: selector ofClass: self classRef)
		inClass: self classRef
		inContext: context! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 12:47'!
isDescendantOfMethodCat: aMethodCatNode
	^ aMethodCatNode containsMethod: self reference! !

!OBMethodNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:57'!
actions
	^ 	{self action: #printOut withLabel: 'print out'.
		self action: #fileOut withLabel: 'file out'.
		self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser'.
		self action: #chaseSenders buttonLabel: 'senders' menuLabel: 'chase senders'.
		self action: #chaseImplementors buttonLabel: 'implementors' menuLabel: 'chase implementors'.
		self action: #browseVersions buttonLabel: 'versions' menuLabel: 'browse versions'.
		self action: #browseInheritance buttonLabel: 'inheritance' menuLabel: 'browse method inheritance'.
		self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables'.
		self action: #browseSenders withLabel: 'browse senders...'.
		self action: #browseImplementors withLabel: 'browse implementors...'.
		self action: #remove withLabel: 'remove' withKeystroke: $x withIcon: MenuIcons deleteIcon}! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/11/2004 21:32'!
senders
	^ self sendersOf: selector! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/22/2004 23:44'!
inheritanceRoot
	| rootClass |
	rootClass _ (context inheritanceOf: selector inClass: self classRef) last.
	^ OBCollectionNode on: {OBMethodNode 
							nakedOn: selector 
							inClass: rootClass 
							inContext: context}! !

!OBMethodNode class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 23:40'!
on: aSelector inClass: aClassReference inContext: aCodeContext
	^ self new setSelector: aSelector class: aClassReference context: aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 14:41'!
printOut
	context printOutMethod: selector fromClass: classRef! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/8/2004 14:25'!
selector
	^ selector! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 3/23/2004 23:11'!
selectorAndMessages
	^ self messages copyWithFirst: self messageNode! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/15/2004 19:04'!
chaseSenders
	OBBrowser 
		browse: #ChaseSenders 
		fromRoot: self copy
		panes: 4! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 3/11/2004 20:54'!
isNaked
	^ isNaked ifNil: [isNaked _ false]! !

!OBMethodNode class methodsFor: 'instance creation' stamp: 'cwp 3/11/2004 20:55'!
nakedOn: aMethodReference inContext: aCodeContext
	^ (self on: aMethodReference inContext: aCodeContext) beNaked! !

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 3/22/2004 23:24'!
setSelector: aSelector class: aClassReference context: aCodeContext
	classRef _ aClassReference.
	selector _ aSelector.
	context _ aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 22:47'!
browse
	Browser fullOnClass: self classRef theClass selector: selector! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 3/15/2004 19:04'!
browseVersions
	OBBrowser browse: #Versions fromRoot: self copy! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/21/2004 20:25'!
removeAndBrowse
	self simpleBrowseSenders.
	context removeMethod: selector fromClass: self classRef.
	self signalDeletion! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 3/11/2004 21:53'!
sendersOf: aSelector
	^ (context allSendersOf: aSelector) 
			collect: [:ref | OBMessageNode on: aSelector inMethodReference: ref inContext: context]! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 3/21/2004 21:29'!
isDescendantOfClass: aClassNode
	^ self theClassName = aClassNode theClassName! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 5/11/2004 10:01'!
nonMetaClassRef
	^ self classRef copy beNonMeta! !

!OBClassAwareNode methodsFor: 'public' stamp: 'cwp 3/22/2004 22:59'!
classRef	
	^ classRef! !

OBClassAwareNode subclass: #OBClassCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassCommentNode methodsFor: 'definition' stamp: 'cwp 3/19/2004 21:47'!
text: aText
	context setCommentForClass: self classRef to: aText.
	^ true! !

!OBClassCommentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 3/21/2004 21:43'!
on: classRef inContext: aContext
	^ self new setClass: classRef context: aContext! !

!OBClassCommentNode methodsFor: 'initializing' stamp: 'cwp 3/21/2004 21:54'!
setClass: aClassReference context: aContext
	classRef _ aClassReference.
	context _ aContext! !

!OBClassCommentNode methodsFor: 'actions' stamp: 'cwp 3/23/2004 23:41'!
actions
	^ Array
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		with: (self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables')! !

!OBClassCommentNode methodsFor: 'public' stamp: 'cwp 3/21/2004 20:56'!
name
	^ self classRef name asString! !

!OBClassCommentNode methodsFor: 'definition' stamp: 'cwp 3/19/2004 21:36'!
text
	^ context commentForClass: self classRef! !

OBCodeNode subclass: #OBClassCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassCategoryNode methodsFor: 'initializing' stamp: 'cwp 12/14/2003 21:08'!
setName: aString context: aCodeContext
	name _ aString.
	context _ aCodeContext.
! !

!OBClassCategoryNode methodsFor: 'drag and drop' stamp: 'cwp 3/2/2004 21:30'!
dropSelector
	^ #dropOnClassCategory:! !

!OBClassCategoryNode methodsFor: 'private' stamp: 'cwp 3/21/2004 21:46'!
classRefs
	^ context classesInCategory: name! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/14/2004 11:39'!
alphabetizeCategoriesInContext: aContext
	aContext sortCategories.
	OBListChanged signal.! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/12/2004 11:26'!
findClassInContext: aContext
	| pattern className |
	pattern _ OBTextRequest 
					prompt: 'Please type the name or fragment to look for' 
					template: ''.
	pattern ifNil: [^self].
	className _ aContext findClass: pattern.
	className ifNotNil: [(OBClassNode 
							on: className
							inContext: aContext) signalSelection].! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'cwp 2/28/2004 21:58'!
createInContext: aContext
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: 'Category-Name'.
	catName ifNotNil:	[aContext addCategory: catName.
						(OBClassCategoryNode 
							on: catName 
							inContext: aContext) signalSelection]! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: 'cwp 3/3/2004 01:36'!
isDescendantOfClassCat: other
	^ other name = name! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 3/10/2004 01:25'!
browse
	Browser newOnCategory: (context longNameOf: name)! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:52'!
actionsForParent: aNode
	^ Array
		with: (OBAction
				label: 'find class...'
				receiver: self
				selector: #findClassInContext:
				arguments: (Array with: aNode context)
				keystroke: $f)
		with: (OBAction 
				label: 'create category...'
				receiver: self
				selector: #createInContext:
				arguments: (Array with: aNode context)
				icon: MenuIcons newIcon)
		with: (OBAction
				label: 'alphabetize categories'
				receiver: self
				selector: #alphabetizeCategoriesInContext:
				arguments: (Array with: aNode context))
		! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 3/21/2004 21:47'!
comments
	^ self classRefs collect: [:ea | OBClassCommentNode on: ea inContext: context]! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 3/21/2004 22:19'!
classes
	^ self classRefs collect: [:ea | OBClassNode on: ea inContext: context]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 15:52'!
doRemove
	context removeCategory: name.
	self signalDeletion! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 11:47'!
printOut
	context printOutCategory: name.! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: 'cwp 5/2/2004 13:22'!
definition
	^ OBClassDefinition 
		context: context 
		template: (context classCreationTemplateInCategory: self name)! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 15:51'!
remove
	| classes choice |
	classes _ context classesInCategory: name.
	classes isEmpty ifTrue: [^ self doRemove].
	choice _ OBConfirmationRequest prompt: 'Are you sure you want to
remove this system category 
and all its classes?' confirm: 'Remove'.
	choice ifTrue: [^ self doRemove]! !

!OBClassCategoryNode class methodsFor: 'instance creation' stamp: 'cwp 12/10/2003 23:17'!
on: aString inContext: aCodeContext
	^ self new setName: aString context: aCodeContext! !

OBClassCategoryNode subclass: #OBExtensionCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBExtensionCategoryNode methodsFor: 'displaying' stamp: 'cwp 3/23/2004 21:21'!
definition
	^ OBDefinition new! !

!OBExtensionCategoryNode class methodsFor: 'actions' stamp: 'cwp 3/17/2004 23:31'!
actionsForParent: aNode
	^ #()! !

!OBExtensionCategoryNode methodsFor: 'private' stamp: 'cwp 3/21/2004 21:51'!
classRefs
	^ (self package extensionClasses collect: [:ea | OBClassReference to: ea]) asArray sort! !

!OBExtensionCategoryNode methodsFor: 'displaying' stamp: 'cwp 3/16/2004 23:07'!
text
	^ ''! !

!OBExtensionCategoryNode methodsFor: 'private' stamp: 'cwp 3/16/2004 23:17'!
classNames
	^ (self package extensionClasses collect: [:ea | ea name]) asArray sort! !

!OBExtensionCategoryNode methodsFor: 'actions' stamp: 'cwp 3/16/2004 23:23'!
actions
	^ #()! !

!OBExtensionCategoryNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 11:14'!
ancestrySelector
	^ #isDescendantOfExtCat:! !

!OBExtensionCategoryNode class methodsFor: 'instance creation' stamp: 'cwp 3/16/2004 23:09'!
inContext: aContext
	^ self on: '-- extensions --' inContext: aContext! !

!OBExtensionCategoryNode methodsFor: 'accessing' stamp: 'cwp 3/17/2004 21:34'!
package
	^ context package! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'hpt 5/14/2004 11:47'!
fileOut
	context fileOutCategory: name.! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: 'cwp 3/4/2004 00:11'!
name
	^ (name isEmpty)
		ifFalse: [name]
		ifTrue: [context longNameOf: name]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'hpt 5/17/2004 16:53'!
actions
	^ Array
		with: (self action: #printOut withLabel: 'print out')
		with: (self action: #fileOut withLabel: 'file out')
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		with: (self action: #remove withLabel: 'remove' withKeystroke: $x withIcon: MenuIcons deleteIcon)
		with: (self action: #rename withLabel: 'rename...')! !

!OBClassCategoryNode methodsFor: 'class creation' stamp: 'cwp 2/28/2004 10:56'!
isRedefinedBy: definition
	"No class is selected, so the definition can't be a redefinition."
	
	^ false! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: 'cwp 5/10/2004 14:28'!
isDescendantOfPackage: aPackageNode
	^ (aPackageNode context categories) includes: name! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: 'cwp 5/13/2004 13:01'!
isDescendantOfExtCat: other
	^ false! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: 'cwp 3/3/2004 01:26'!
ancestrySelector
	^ #isDescendantOfClassCat:! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 3/21/2004 22:19'!
metaclasses
	^ self classRefs collect: [:ea | OBMetaclassNode on: ea inContext: context]! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: 'cwp 3/16/2004 20:33'!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self name, ''''! !

!OBClassCategoryNode methodsFor: 'private' stamp: 'cwp 3/19/2004 20:51'!
classNames
	^ (context classesInCategory: name) collect: [:ea | ea name]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:42'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name toBe: category.
						name _ category.
						OBListChanged signal]! !

Object subclass: #OBCodeGraphInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBCodeGraphInitializer class methodsFor: 'class initialization' stamp: 'cwp 8/25/2004 17:34'!
initialize
	OBMetaGraphBuilder default installCodeGraphs.
	OBBrowser registerImageBrowser
	! !

Object subclass: #OBImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBImageContext commentStamp: 'cwp 3/5/2004 12:38' prior: 0!
The nodes representing Smalltalk program elements operate within a context which defines the scope of the code visible in the browser. OBImageContext operates on  all the code in the image.!

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 19:07'!
renameClass: classRef toBe: newName
	Smalltalk renameClassNamed: classRef theNonMetaName as: newName! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/3/2004 22:42'!
removeCategory: aString
	SystemOrganization removeSystemCategory: aString! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/19/2004 22:06'!
methodsForClass: classRef
	^ (classRef theClass selectors asArray 
		collect: [:sel | self referenceForMethod: sel ofClass: classRef name])
			sort! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 3/21/2004 21:08'!
accessesToInstVar: instVarName ofClass: classRef
	| accessors |
	accessors _ OrderedCollection new.
	classRef theClass withAllSubAndSuperclassesDo: [:class |
		(class whichSelectorsAccess: instVarName) asSortedCollection
			do: [:ea | ea = #DoIt ifFalse: [accessors add: (self referenceForMethod: ea ofClass: class name)]]].
	^ accessors asArray! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 1/31/2004 13:29'!
longNameOf: classCategory
	^ classCategory! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:47'!
inspectInstancesOfClass: classRef
	classRef theNonMetaClass inspectAllInstances! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/19/2004 22:00'!
inheritanceOf: aSelector inClass: classRef
	^ (classRef theClass allSuperclasses asArray
		select: [:ea | ea includesSelector: aSelector]
		thenCollect: [:ea | OBClassReference to: ea]) copyWithFirst: classRef! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:39'!
browseUnsentMethodsIn: classRef
	| classes unsent messageList |
	classes _ Array 
		with: classRef theNonMetaClass 
		with: classRef theNonMetaClass class.
	unsent _ Set new.
	classes do: [:aClass | unsent addAll: aClass selectors].
	unsent _ self systemNavigation allUnSentMessagesIn: unsent.
	messageList _ OrderedCollection new.
	classes do: [:aClass | 
		(aClass selectors select: [:aSelector | unsent includes: aSelector]) asOrderedCollection
		do: [:aSelector | messageList add: aClass name, ' ', aSelector]].
	self systemNavigation 
			browseMessageList: messageList 
			name: 'Unsent Methods in ' , classRef name.! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 22:54'!
renameCategory: oldName toBe: newName
	SystemOrganization renameCategory: oldName toBe: newName! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 19:01'!
removeClass: classRef
	classRef theClass removeFromSystem.! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/19/2004 18:14'!
addCategory: aString toClass: classRef 
	classRef theClass organization addCategory: aString! !

!OBImageContext methodsFor: 'methods' stamp: 'hpt 5/14/2004 14:41'!
fileOutMethod: selector fromClass: classRef
	classRef theClass fileOutMethod: selector! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:28'!
fileOutClass: classRef
	classRef theNonMetaClass fileOut.! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/21/2004 20:27'!
sourceForMethod: aSelector ofClass: classRef
	^ (classRef theClass sourceCodeAt: aSelector ifAbsent: [^ ''])
			asText makeSelectorBold! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:18'!
classVariablesForClass: classRef
	^ classRef theClass allClassVarNames asArray sort! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 21:12'!
metaclassNamed: aSymbol
	^ (self classNamed: aSymbol) class! !

!OBImageContext methodsFor: 'class categories' stamp: 'hpt 5/14/2004 11:40'!
sortCategories
	Cursor wait showWhile: [SystemOrganization sortCategories]! !

!OBImageContext methodsFor: 'source' stamp: 'cwp 3/14/2004 23:15'!
sourceFiles
	^ SourceFiles! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 12:12'!
findMethodIn: classRef
	| selectors |
	selectors _ classRef theClass selectors asSortedArray.
	selectors isEmpty 
		ifTrue: [^nil].
	^(SelectionMenu labelList: selectors selections: selectors) startUp
! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:12'!
classExists: classRef
	^ Smalltalk hasClassNamed: classRef theNonMetaName! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 3/19/2004 18:07'!
categoryOf: classRef
	^ classRef theNonMetaClass category! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/21/2004 20:23'!
removeMethod: aSelector fromClass: classRef
	classRef theClass removeSelector: aSelector! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 12/17/2003 20:40'!
categories
	^ SystemOrganization categories! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:44'!
instanceVariablesForClass: classRef
	^ classRef theClass allInstVarNames asArray sort! !

!OBImageContext methodsFor: 'finding class' stamp: 'hpt 5/14/2004 11:57'!
findClass: pattern 
	| classNames className |
	classNames _ self classNamesMatching: pattern.
	classNames size = 0 ifTrue: [^ nil].
	classNames size = 1 ifTrue: [^ OBClassReference named: classNames first asSymbol].
	className _ self userSelectionOf: classNames for: (pattern copyWithout: $.) asLowercase.
	^className ifNotNil: [OBClassReference named: className]! !

!OBImageContext methodsFor: 'method categories' stamp: 'hpt 5/14/2004 14:34'!
fileOutCategory: name fromClass: classRef
	classRef theClass fileOutCategory: name! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/19/2004 18:02'!
categoriesForClass: classRef
	^ classRef theClass organization categories! !

!OBImageContext methodsFor: 'methods' stamp: 'hpt 5/14/2004 14:41'!
printOutMethod: selector fromClass: classRef
	classRef fileOutMethod: selector asHtml: true.! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 3/19/2004 17:54'!
accessesToClassVar: classVarName ofClass: classRef
	| literal |
	literal _ (classRef theClass withAllSuperclasses 
				gather: [:ea | ea classPool associations])
					detect: [:ea | ea key = classVarName].
	^ (self systemNavigation allCallsOn: literal) asArray sort! !

!OBImageContext methodsFor: 'class categories' stamp: 'hpt 5/14/2004 11:49'!
fileOutCategory: aString.
	SystemOrganization fileOutCategory: aString.! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:46'!
setCommentForClass: classRef to: aText
	^ classRef theClass comment: aText stamp: Utilities changeStamp! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 21:17'!
addCategory: aString
	SystemOrganization addCategory: aString! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 1/31/2004 13:40'!
methodCategoryOf: aMethodReference
	^ aMethodReference actualClass organization 
		categoryOfElement: aMethodReference methodSymbol! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 15:02'!
referenceForMethod: selector ofClass: className
	^ MethodReference new 
		setClassSymbol: className
		classIsMeta: false
		methodSymbol: selector
		stringVersion: className, '>>', selector! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 3/19/2004 21:06'!
setCategoryOf: classRef to: catName
	classRef theNonMetaClass category: catName! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/21/2004 22:21'!
defineClass: definition notifying: aController
	| evaluator newClass |
	evaluator _ self evaluatorForDefinition: definition.
	newClass _ evaluator
				evaluate: definition
				notifying: aController
				logged: true.
	^ newClass ifNotNil: [OBClassReference to: newClass]! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/17/2004 22:05'!
starLongNameOf: classCategory
	^ classCategory! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 3/3/2004 22:44'!
allImplementorsOf: aSelector
	^ (self systemNavigation allImplementorsOf: aSelector) asArray sort! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:28'!
printOutClass: classRef
	classRef theNonMetaClass fileOutAsHtml: true! !

!OBImageContext methodsFor: 'method categories' stamp: 'hpt 5/14/2004 14:35'!
printOutCategory: name fromClass: classRef
	classRef theClass fileOutCategory: name asHtml: true! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/20/2004 12:38'!
methodsInCategory: catName ofClass: classRef
	^ (classRef theClass organization listAtCategoryNamed: catName)
		 collect: [:sel | self referenceForMethod: sel ofClass: classRef name]! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 3/15/2004 20:44'!
evaluatorForDefinition: definition
	| tokens |
	tokens _ Scanner new scanTokens: definition.
	^ (self classNamed: tokens first) subclassDefinerClass! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 3/20/2004 12:40'!
overridersOf: aSelector inClass: classRef
	| classes |
	classes _ OrderedCollection new.
	self addOverridersOf: aSelector inClass: classRef theClass to: classes.
	^ (classes collect: [:ea | OBClassReference to: ea]) asArray sort.! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 5/30/2004 16:35'!
addOverridersOf: aSelector inClass: aClass to: aCollection
	aClass subclasses do: 
		[:ea | (ea includesSelector: aSelector)
					ifTrue: [aCollection add: ea]
					ifFalse: [self addOverridersOf: aSelector inClass: ea to: aCollection]]! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:38'!
browseUnreferencedInstVarsIn: classRef
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"
	| aList |
	aList _ classRef theClass allUnreferencedInstanceVariables.
	aList isEmpty ifTrue: [^ self inform: 'There are no unreferenced', String cr, 
											'instance variables in', String cr, classRef name]. 
	(SelectionMenu labels: aList selections: aList) 
		startUpWithCaption: 'Unreferenced', String cr, 'instance variables in', String cr,
								classRef name.! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:36'!
commentForClass: classRef
	^ classRef theClass comment! !

!OBImageContext methodsFor: 'finding class' stamp: 'hpt 5/11/2004 18:26'!
classNamesMatching: pattern 
	| potentialClassNames toMatch |
	toMatch := (pattern copyWithout: $.) asLowercase.
	potentialClassNames := self potentialClassNames asOrderedCollection.
	^ pattern last = $.
		ifTrue: [potentialClassNames
				select: [:nm | nm asLowercase = toMatch]]
		ifFalse: [potentialClassNames
				select: [:n | n includesSubstring: toMatch caseSensitive: false]]! !

!OBImageContext methodsFor: 'method categories' stamp: 'hpt 5/14/2004 14:21'!
removeEmptyCategoriesInClass: classRef
	classRef theClass organization removeEmptyCategories! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 5/11/2004 12:06'!
classNamed: aSymbol
	^ (aSymbol endsWith: ' class')
		ifTrue: [self metaclassNamed: (aSymbol allButLast: 6) asSymbol]
		ifFalse: [Smalltalk at: aSymbol ifAbsent: [nil]]! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 14:12'!
copyClass: originalClassRef toBe: copysName
	| class oldDefinition newDefinition |
	(Smalltalk includesKey: copysName)
		ifTrue: [^self error: copysName, ' already exists'].
	oldDefinition _ originalClassRef theNonMetaClass definition.
	newDefinition _ oldDefinition copyReplaceAll: '#' , originalClassRef theNonMetaName asString with: '#' , copysName asString.
	Cursor wait 
		showWhile: [class _ Compiler evaluate: newDefinition logged: true.
					class copyAllCategoriesFrom: originalClassRef theNonMetaClass.
					class class copyAllCategoriesFrom: originalClassRef theNonMetaClass class].! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:47'!
inspectSubInstancesOfClass: classRef
	classRef theNonMetaClass inspectSubInstances! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 3/19/2004 21:41'!
definitionForClass: classRef
	^ classRef theClass definition! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 5/2/2004 13:21'!
classCreationTemplateInCategory: aString
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', aString, ''''! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:37'!
browseUnreferencedClassVarsIn: classRef
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	| aList |
	aList _ self systemNavigation allUnreferencedClassVariablesOf: classRef theClass.
	aList isEmpty 
		ifTrue: [^ self inform: 'There are no unreferenced', String cr, 'class variables in',
					 			String cr, classRef name].
	(SelectionMenu labels: aList selections: aList)
		startUpWithCaption: 'Unreferenced', String cr, 'class variables in', String cr,
								classRef name! !

!OBImageContext methodsFor: 'classes' stamp: 'hpt 5/14/2004 13:32'!
browseAllCallsOnClass: classRef
	self systemNavigation browseAllCallsOnClass: classRef theNonMetaClass! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 3/21/2004 20:35'!
messagesSentBy: aSelector inClass: classRef
	^ ((classRef theClass compiledMethodAt: aSelector ifAbsent: [^ #()]) messages) asArray sort! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 3/3/2004 22:44'!
allSendersOf: aSelector
	^ (self systemNavigation allCallsOn: aSelector) asArray sort! !

!OBImageContext methodsFor: 'finding class' stamp: 'hpt 5/11/2004 17:47'!
potentialClassNames
	"Answer the names of all the classes that could be viewed within this context."
	^Smalltalk classNames! !

!OBImageContext methodsFor: 'class categories' stamp: 'hpt 5/14/2004 11:49'!
printOutCategory: aString
	SystemOrganization fileOutCategory: aString asHtml: true! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/19/2004 18:14'!
renameCategory: oldName inClass: classRef toBe: newName 
	classRef theClass organization renameCategory: oldName toBe: newName! !

!OBImageContext methodsFor: 'source' stamp: 'cwp 3/14/2004 23:19'!
sourcePointerFor: aMethodReference
	| class selector |
	class _ aMethodReference actualClass.
	selector _ aMethodReference methodSymbol.
	^ (class compiledMethodAt: selector) sourcePointer! !

!OBImageContext methodsFor: 'method categories' stamp: 'hpt 5/14/2004 14:21'!
categorizeAllUncategorizedMethodsInClass: classRef
	"Categorize methods by looking in parent classes for a method category."
	| organizer organizers |
	organizer _ classRef theClass organization.
	organizers _ classRef theClass withAllSuperclasses collect: [:ea | ea organization].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found _ (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [organizer classify: sel under: found]].! !

!OBImageContext methodsFor: 'finding class' stamp: 'hpt 5/11/2004 19:21'!
userSelectionOf: classNames for: toMatch 
	| exactMatch lines index |
	exactMatch _ classNames	detect: [:ea | ea asLowercase = toMatch] 
								ifNone: [nil].
	lines _ #().
	exactMatch ifNotNil:	[classNames addFirst: exactMatch.
							lines _ #(1)].
	index _ (PopUpMenu labelArray: classNames lines: lines) startUp.
	index isZero
		ifTrue: [^ nil].
	^ (classNames at: index) asSymbol! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 3/19/2004 18:41'!
classesInCategory: aCategory
	^ (SystemOrganization listAtCategoryNamed: aCategory asSymbol)
		collect: [:ea | OBClassReference named: ea]! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/19/2004 21:50'!
setCategoryOf: aSelector inClass: classRef toBe: catName
	classRef theClass organization classify: aSelector under: catName! !

!OBImageContext methodsFor: 'method categories' stamp: 'hpt 5/17/2004 16:14'!
removeCategory: aString fromClass: classRef 
	classRef theClass removeCategory: aString! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 3/19/2004 21:57'!
sortCategoriesInClass: classRef
	classRef theClass organization sortCategories! !

Object subclass: #OBMethodVersion
	instanceVariableNames: 'sources pointer classRef className category stamp prior selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 3/13/2004 13:37'!
setSources: aSourceFileArray pointer: aSourcePointer
	sources _ aSourceFileArray.
	pointer _ aSourcePointer.
	self parseSource.! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 3/13/2004 13:55'!
stamp
	^ stamp! !

!OBMethodVersion class methodsFor: 'instance creation' stamp: 'cwp 3/13/2004 13:35'!
fromSources: sources andPointer: pointer
	^ self new setSources: sources pointer: pointer! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 5/11/2004 10:35'!
theClass
	^ classRef theClass! !

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 3/13/2004 13:46'!
previous
	^ prior ifNotNil: [self class fromSources: sources andPointer: prior]! !

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 3/14/2004 23:38'!
setSelector
	| file |
	file _ sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ selector _ Parser new parseSelector: file nextChunk.! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 5/11/2004 10:34'!
classSymbol
	^ classRef name! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 3/14/2004 23:37'!
selector
	^ selector ifNil: [self setSelector]! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 3/14/2004 23:10'!
source
	| file |
	file _ sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunk asText makeSelectorBold! !

!OBMethodVersion class methodsFor: 'scanning' stamp: 'cwp 3/13/2004 15:13'!
scan: sources from: pointer 
	| versions current |
	
	versions _ OrderedCollection new.
	current _ OBMethodVersion fromSources: sources andPointer: pointer.
	[current notNil]
		whileTrue: [versions add: current.
					current _ current previous].
	^ versions! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 5/11/2004 10:35'!
theClassName
	^ classRef name! !

!OBMethodVersion class methodsFor: 'scanning' stamp: 'cwp 3/13/2004 15:14'!
versionsOfMethod: methodReference 
	| class selector |
	class _ methodReference actualClass.
	selector _ methodReference methodSymbol.
	^ self scan: SourceFiles from: (class compiledMethodAt: selector) sourcePointer! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 5/11/2004 10:34'!
classRef
	^ classRef! !

!OBMethodVersion methodsFor: 'compiling' stamp: 'cwp 3/14/2004 00:15'!
fileIn
	(self theClass) ifNotNilDo: [:class | class
						 				compile: self source 
										classified: self category 
										withStamp: self stamp 
										notifying: nil]
						
						! !

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 5/11/2004 10:42'!
parseChunk: aString
	| tokens |
	tokens _ Scanner new scanTokens: aString.
	classRef _ OBClassReference named: tokens first.
	tokens second = #class
		ifTrue: [classRef beMeta.
				category _ tokens fourth.
				stamp _ tokens sixth]
		ifFalse: [category _ tokens third.
				stamp _ tokens fifth].
	tokens size > 6 ifTrue: [prior _ tokens last].! !

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 5/11/2004 11:44'!
parseSource
	| file position chunk |
	file _ sources at: (sources fileIndexFromSourcePointer: pointer).
	position _ sources filePositionFromSourcePointer: pointer.
	position > file size ifTrue: [self error: 'Invalid source pointer'].
	
	file position: (0 max: position-150).  	"Skip back to before the preamble"
		[file position < (position-1)]  	"then pick it up from the front"
			whileTrue: [chunk _ file nextChunk].
	
	self parseChunk: chunk.! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 3/13/2004 13:52'!
category
	^ category! !

Object subclass: #OBClassReference
	instanceVariableNames: 'name isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBClassReference methodsFor: 'comparing' stamp: 'cwp 3/19/2004 18:30'!
hash
	^ isMeta
		ifTrue: [name hash bitInvert]
		ifFalse: [name hash]! !

!OBClassReference methodsFor: 'testing' stamp: 'cwp 5/11/2004 10:21'!
beNonMeta
	isMeta _ false! !

!OBClassReference methodsFor: 'accessing' stamp: 'cwp 3/21/2004 22:05'!
theNonMetaName: aSymbol
	name _ aSymbol! !

!OBClassReference methodsFor: 'comparing' stamp: 'cwp 3/20/2004 12:30'!
= other
	^ (other isKindOf: OBClassReference) 
		and: [name = other theNonMetaName] 
		and: [isMeta = other isMeta]! !

!OBClassReference methodsFor: 'converting' stamp: 'cwp 3/23/2004 22:04'!
referenceToMethod: aSelector
	| ref |
	ref _ MethodReference new.
	ref setClassSymbol: name classIsMeta: isMeta  methodSymbol: aSelector stringVersion: ''.
	^ ref! !

!OBClassReference methodsFor: 'accessing' stamp: 'cwp 3/19/2004 19:02'!
theNonMetaName
	^ name! !

!OBClassReference class methodsFor: 'instance creation' stamp: 'cwp 5/11/2004 10:08'!
metaNamed: aSymbol
	^ (self named: aSymbol) beMeta! !

!OBClassReference methodsFor: 'accessing' stamp: 'cwp 3/19/2004 18:10'!
theClass
	| theClass |
	theClass _ self theNonMetaClass ifNil: [^ nil].
	^ isMeta
		ifFalse: [theClass]
		ifTrue: [theClass class]! !

!OBClassReference methodsFor: 'testing' stamp: 'cwp 3/19/2004 18:44'!
isMeta
	^ isMeta! !

!OBClassReference class methodsFor: 'instance creation' stamp: 'cwp 3/19/2004 17:44'!
to: aClass
	^ self named: aClass name! !

!OBClassReference class methodsFor: 'instance creation' stamp: 'cwp 3/19/2004 17:58'!
named: aSymbol
	^ self new setName: aSymbol! !

!OBClassReference methodsFor: 'accessing' stamp: 'cwp 3/19/2004 18:09'!
theNonMetaClass
	^ Smalltalk at: name ifAbsent: [].! !

!OBClassReference methodsFor: 'comparing' stamp: 'cwp 3/21/2004 20:12'!
<= other
	^ self name <= other name! !

!OBClassReference methodsFor: 'testing' stamp: 'cwp 3/21/2004 22:11'!
beMeta
	isMeta _ true! !

!OBClassReference methodsFor: 'initializing' stamp: 'cwp 3/19/2004 17:58'!
setName: aSymbol
	name _ (aSymbol copyUpTo: $ ) asSymbol.
	isMeta _ aSymbol endsWith: ' class'.! !

!OBClassReference methodsFor: 'accessing' stamp: 'cwp 3/19/2004 19:02'!
name
	^ isMeta
		ifTrue: [name, ' class']
		ifFalse: [name]! !

!OBClassReference methodsFor: 'printing' stamp: 'cwp 3/19/2004 18:38'!
printOn: aStream
	aStream nextPutAll: 'OBClassReference'.
	aStream nextPut: $<.
	aStream nextPutAll: name.
	isMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream nextPut: $>.! !

Object subclass: #OBNotifier
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBNotifier commentStamp: 'cwp 3/5/2004 14:30' prior: 0!
This class refreshes in response to SystemChangeNotifications. There is only one instance.!

!OBNotifier class methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2004 23:58'!
createInstance
	^ Instance _ super new.! !

!OBNotifier class methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2004 23:51'!
new
	self error: 'Only one instance should be exist.'! !

!OBNotifier methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2004 14:27'!
event: anEvent
	[OBBrowser allInstancesDo: [:ea | ea isOpen ifTrue: [ea refresh]]] fork! !

!OBNotifier class methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2004 23:53'!
initialize
	^ self uniqueInstance register! !

!OBNotifier class methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2004 23:51'!
uniqueInstance
	^ Instance ifNil: [self createInstance]! !

!OBNotifier methodsFor: 'as yet unclassified' stamp: 'cwp 3/1/2004 23:56'!
register
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/23/2004 23:49'!
chaseVarsBrowser
	| class method message var |
	class _ OBMetaNode named: 'Class'.
	var _ OBMetaNode named: 'Variable'.
	method _ OBMetaNode named: 'Method'.
	message _ OBMetaNode named: 'Message'.
	class
		addActor: OBNodeActor new;
		childAt: #instanceVariables labeled: 'instance' put: var;
		childAt: #classVariables labeled: 'class' put: var;
		filterClass: OBModalFilter.
	var
		childAt: #accessors put: method;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	method
		addActor: OBNodeActor new;
		childAt: #senders put: message;
		filterClass: OBModalFilter.
	message
		addActor: OBNodeActor new;
		childAt: #senders put: message;
		filterClass: OBModalFilter.
	
	^ class! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 8/25/2004 17:24'!
imageBrowser
	| class methodCategory method metaclass comment environment classCategory |
	environment _ OBMetaNode named: 'Environment'.
	classCategory _ OBMetaNode named: 'ClassCategory'.
	class _ OBMetaNode named: 'Class'.
	comment _ OBMetaNode named: 'ClassComment'.
	metaclass _ OBMetaNode named: 'Metaclass'.
	methodCategory _ OBMetaNode named: 'MethodCategory'.
	method _ OBMetaNode named: 'Method'.

	environment
		childAt: #categories put: classCategory.
	classCategory 
		childAt: #classes labeled: 'instance' put: class;
		childAt: #comments labeled: '?' put: comment;
		childAt: #metaclasses labeled: 'class' put: metaclass;
		filterClass: OBModalFilter.
	class 
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new.
	comment
		addActor: OBNodeActor new.
	metaclass
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new.
	methodCategory 
		childAt: #methods put: method;
		addActor: (OBNodeActor onNodeClass: OBMethodCategoryNode).
	method 
		addActor: OBNodeActor new.
		
	^ environment! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/14/2004 14:57'!
chaseImplementorsBrowser
	| method message |
	method _ OBMetaNode named: 'Method'.
	message _ OBMetaNode named: 'Message'.
	
	method 
		childAt: #selectorAndMessages labeled: 'messages' put: message;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	message
		childAt: #implementors put: method;
		childAt: #sendersOfMessage labeled: 'senders' put: method;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	^ method! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-installing' stamp: 'cwp 8/25/2004 17:16'!
installCodeGraphs
	OBBrowser 

		"Code browsers"
		metaGraphAt: #Image put: self imageBrowser;
		metaGraphAt: #Implementors put: self implementorsBrowser;
		metaGraphAt: #Senders put: self sendersBrowser;
		metaGraphAt: #Versions put: self versionsBrowser;
		metaGraphAt: #MethodInheritance put: self inheritanceBrowser;
		
		"Experimental chasing browsers"
		metaGraphAt: #ChaseImplementors put: self chaseImplementorsBrowser;
		metaGraphAt: #ChaseSenders put: self chaseSendersBrowser;
		metaGraphAt: #ChaseVariables put: self chaseVarsBrowser.! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/6/2004 21:51'!
sendersBrowser
	| method senders |
	method _ OBMetaNode named: 'Method'.
	senders _ OBMetaNode named: 'Implementors'.
	
	method
		childAt: #senders put: senders;
		addActor: OBNodeActor new.
	senders
		addActor: OBNodeActor new.
		
	^ method! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/14/2004 23:53'!
versionsBrowser
	| version |
	version _ OBMetaNode named: 'Version'.
	version addActor: OBNodeActor new.
	^ (OBMetaNode named: 'Method') 
		childAt: #versions put: version.! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/6/2004 21:41'!
implementorsBrowser
	| implementors method |
	method _ OBMetaNode named: 'Method'.
	implementors _ OBMetaNode named: 'Implementors'.
	
	method
		childAt: #implementors put: implementors;
		addActor: OBNodeActor new.
	implementors
		addActor: OBNodeActor new.
		
	^ method! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/15/2004 23:22'!
inheritanceBrowser
	| method root |
	method _ OBMetaNode named: 'Method'.
	root _ OBMetaNode named: 'Root'.
	root
		childAt: #children put: method.
	method
		childAt: #overrides put: method;
		addActor: OBNodeActor new.
	^ root! !

!OBMetaGraphBuilder methodsFor: '*ob-standard-browsers' stamp: 'cwp 3/14/2004 14:57'!
chaseSendersBrowser
	| method message |
	method _ OBMetaNode named: 'Method'.
	message _ OBMetaNode named: 'Message'.
	
	method 
		childAt: #selectorAndMessages labeled: 'messages' put: message;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	message
		childAt: #sendersOfMessage labeled: 'senders' put: method;
		childAt: #implementors put: method;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	^ method! !

!BogusInfo class methodsFor: '*ob-standard-references' stamp: 'cwp 5/30/2004 10:04'!
aMetaRef
	^ OBClassReference metaNamed: #BogusA! !

!BogusInfo class methodsFor: '*ob-standard-references' stamp: 'cwp 5/30/2004 18:31'!
bMetaRef
	^ OBClassReference metaNamed: #BogusB! !

!BogusInfo class methodsFor: '*ob-standard-references' stamp: 'cwp 5/30/2004 08:45'!
bRef
	^ OBClassReference named: #BogusB! !

!BogusInfo class methodsFor: '*ob-standard-references' stamp: 'cwp 5/30/2004 08:45'!
aRef
	^ OBClassReference named: #BogusA! !

TestCase subclass: #OBMethodVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBMethodVersionTest methodsFor: 'testing' stamp: 'cwp 3/21/2004 21:32'!
testScanFromPointer
	| changes sourcePointer sources |
	sources _  self fakeSourceFileArray.
	sourcePointer _ sources sourcePointerFromFileIndex: 2 andPosition: 518.
	changes _ OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 6.
	changes do: [:ea | 
					self assert: ea theClassName = #OBFakeClassC.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

!OBMethodVersionTest methodsFor: 'testing' stamp: 'cwp 3/13/2004 15:11'!
testScanFromMethodRef
	| changes |
	changes _ OBMethodVersion versionsOfMethod: self methodReference.
	self deny: changes isEmpty! !

!OBMethodVersionTest methodsFor: 'constants' stamp: 'cwp 3/13/2004 14:03'!
methodReference
	| ref |
	ref _ MethodReference new.
	ref setStandardClass: self class methodSymbol: #testScanFromMethodRef.
	^ ref! !

!OBMethodVersionTest methodsFor: 'testing' stamp: 'cwp 5/11/2004 11:46'!
testScanFromPointerToClassMethod
	| changes sourcePointer sources |
	sources _  self fakeSourceFileArray.
	sourcePointer _ sources sourcePointerFromFileIndex: 2 andPosition: 736.
	changes _ OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 2.
	changes do: [:ea | 
					self assert: ea theClassName = #'OBFakeClassC class'.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

!OBMethodVersionTest methodsFor: 'constants' stamp: 'cwp 3/13/2004 22:39'!
fakeSourceFileArray
	^ OBSourceFilesResource current sources! !

TestCase subclass: #OBSilentTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBSilentTestCase methodsFor: 'running' stamp: 'cwp 2/29/2004 12:36'!
runCaseAsFailure: aSemaphore
	SystemChangeNotifier uniqueInstance doSilently: [super runCaseAsFailure: aSemaphore]! !

!OBSilentTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2004 21:27'!
isAbstract
	^ self name = #OBSilentTestCase! !

!OBSilentTestCase methodsFor: 'running' stamp: 'cwp 2/29/2004 12:34'!
runCase
	SystemChangeNotifier uniqueInstance doSilently: [super runCase]! !

OBSilentTestCase subclass: #OBCodeSanityCheckTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: 'cwp 3/16/2004 14:55'!
codeContext
	^ OBImageContext new! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: 'cwp 2/28/2004 11:24'!
selectionInterval
	^ 1 to: 0! !

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 11:03'!
bogusCDefinition
	^ 'Object subclass: #BogusC
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 11:04'!
testClassCreation
	node _ OBClassCategoryNode on: BogusInfo baseCategory inContext: self codeContext.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 11:04'!
testClassDefinition
	node _ OBClassNode on: BogusInfo aRef inContext: self codeContext.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: 'cwp 5/30/2004 11:05'!
testClassRedefinition
	node _ OBClassNode on: BogusInfo aRef inContext: self codeContext.
	self 
		shouldnt: [node accept: self bogusARedefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: 'cwp 5/30/2004 11:02'!
bogusARedefinition
	^ BogusA definition! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: 'cwp 2/28/2004 11:27'!
text
	^ node text asText! !

OBDefinition subclass: #OBClassDefinition
	instanceVariableNames: 'context template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBClassDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 21:13'!
text
	^ template! !

!OBClassDefinition methodsFor: 'class definition' stamp: 'cwp 3/22/2004 21:05'!
defineClass: definition notifying: aController
	| newClassRef |
	(self confirmDefinition: definition) ifFalse: [^ false].
	newClassRef _ context defineClass: definition notifying: aController.
	newClassRef ifNil: [^ false].
	self signalSelectionOf: newClassRef.
	^ true
! !

!OBClassDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 21:14'!
selection
	^ 1 to: 0! !

!OBClassDefinition class methodsFor: 'instance creation' stamp: 'cwp 3/22/2004 21:18'!
context: aContext template: aString 
	^ self new setContext: aContext template: aString! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 3/22/2004 21:08'!
confirmDefinition: definition
	"Check to make sure the user isn't accidentally over-writing an existing class."
	
	(((self isRedefinition: definition) not) and: [self definedClassExists: definition])
		ifTrue: [^ self confirmRedefinition: definition]
		ifFalse: [^ true]! !

!OBClassDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 21:05'!
accept: aText notifying: aController
	^ self defineClass: aText notifying: aController! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 3/22/2004 21:09'!
definedClassExists: definition
	^ context classExists: (OBClassReference named: (self nameOfClassDefinedBy: definition))! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 3/22/2004 21:11'!
nameOfClassDefinedBy: definition
	^ (Scanner new scanTokens: definition) third! !

!OBClassDefinition methodsFor: 'accessing' stamp: 'cwp 3/23/2004 00:04'!
classRef
	^ OBClassReference named: (self nameOfClassDefinedBy: template)! !

!OBClassDefinition methodsFor: 'initializing' stamp: 'cwp 3/22/2004 20:59'!
setContext: aContext template: aText
	context _ aContext.
	template _ aText.! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 3/22/2004 21:09'!
isRedefinition: aDefinition
	^ (self nameOfClassDefinedBy: aDefinition) = (self nameOfClassDefinedBy: template)! !

!OBClassDefinition methodsFor: 'class definition' stamp: 'cwp 3/22/2004 21:12'!
signalSelectionOf: aClassRef
	((aClassRef isMeta
		ifTrue: [OBMetaclassNode] 
		ifFalse: [OBClassNode]) 
			on: aClassRef 
			inContext: context) signalSelection! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 3/22/2004 21:10'!
confirmRedefinition: definition
	| newName prompt |
	newName _ self nameOfClassDefinedBy: definition.
	prompt _ (newName, ' is an existing class in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText.
	^ OBConfirmationRequest
		prompt: prompt
		confirm: 'Redefine'! !

OBDefinition subclass: #OBMethodDefinition
	instanceVariableNames: 'context classRef category source selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 3/23/2004 22:21'!
inCategory: aString inClass: aClassReference inContext: aContext
	^ self new 
		setContext: aContext 
		class: aClassReference 
		category: aString
		source: nil 
		selection: nil! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 22:26'!
selection
	^ selection ifNil: [1 to: (source ifNil: [self text size] ifNotNil: [0])]! !

!OBMethodDefinition methodsFor: 'confirming' stamp: 'cwp 3/23/2004 22:00'!
selectorAlreadyDefined: aSelector
	^ ((context methodsForClass: self classRef) 
			collect: [:ref | ref methodSymbol]) includes: aSelector! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 3/23/2004 22:08'!
inClass: aClassReference inContext: aContext
	^ self new setContext: aContext class: aClassReference source: nil selection: nil! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'cwp 3/23/2004 21:58'!
selector
	^ source ifNotNil: [Parser new parseSelector: source]! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'cwp 3/23/2004 22:33'!
classRef
	^ classRef! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 22:47'!
text
	^ source ifNil: [self classRef theClass sourceCodeTemplate]! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'cwp 3/23/2004 22:47'!
compileMethod: aText notifying: aController
	^ (self confirmMethod: aText)
		ifTrue: [self classRef theClass 
					compile: aText 
					classified: self category 
					notifying: aController]
		ifFalse: [nil]! !

!OBMethodDefinition methodsFor: 'initializing' stamp: 'cwp 3/23/2004 22:21'!
setContext: aContext class: aClassReference category: aString source: aText selection: anInterval
	context _ aContext.
	classRef _ aClassReference.
	category _ aString.
	source _ aText.
	selection _ anInterval.! !

!OBMethodDefinition methodsFor: 'confirming' stamp: 'cwp 3/23/2004 22:00'!
confirmScarySelector: aSelector
	| prompt |
	prompt _ aSelector, ' is used in the existing class system.
Overriding it could cause serious problems.
Is this really what you want to do?'.

	^ OBConfirmationRequest
		prompt: prompt
		confirm: 'Override'! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 23:18'!
accept: aText notifying: aController
	| newSelector |
	newSelector _ self compileMethod: aText notifying: aController.
	newSelector ifNil: [^ false].
	newSelector = self selector 
		ifTrue: [source _ context sourceForMethod: newSelector ofClass: classRef]
		ifFalse: [(self methodNodeFor: newSelector) signalSelection].
	^ true! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 3/23/2004 22:38'!
selection: anInterval source: aText inClass: aClassReference inContext: aContext 
	^ self new
		setContext: aContext
		class: aClassReference
		category: nil
		source: aText
		selection: anInterval! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 3/23/2004 22:37'!
source: aText inClass: aClassReference inContext: aContext 
	^ self new
		setContext: aContext
		class: aClassReference
		category: nil
		source: aText
		selection: nil! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'cwp 3/23/2004 22:12'!
methodNodeFor: aSelector
	^ OBMethodNode 
		on: aSelector
		inClass: classRef
		inContext: context! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'cwp 3/23/2004 22:23'!
category
	^ category ifNil: [context methodCategoryOf: (classRef referenceToMethod: self selector)]! !

!OBMethodDefinition methodsFor: 'confirming' stamp: 'cwp 3/23/2004 21:59'!
confirmMethod: aText
	| sel |
	sel _ Parser new parseSelector: aText.
	^ (classRef isMeta 
			and: [(self selectorAlreadyDefined: sel) not] 
			and: [Metaclass isScarySelector: sel])
				ifTrue: [self confirmScarySelector: sel]
				ifFalse: [^ true]! !
OBCodeGraphInitializer initialize!
OBNotifier initialize!
